#include "config.h"

#include <stdio.h>
#include <stdlib.h>

/* need vcl.h before vrt.h for vmod_evet_f typedef */
#include "vcl.h"
#include "vrt.h"
#include "cache/cache.h"

#include "vtim.h"
#include "vcc_blobsynth_if.h"

VCL_VOID
vmod_synthetic(VRT_CTX, VCL_BLOB blob)
{
	struct vsb *vsb;

	if ((ctx->method & (VCL_MET_SYNTH | VCL_MET_BACKEND_ERROR)) == 0) {
		VSLb(ctx->vsl, SLT_VCL_Error,
		    "blobsynth.synthetic() only valid in vcl_synth{}"
		    " and vcl_backend_error{}");
		return;
	}

	CAST_OBJ_NOTNULL(vsb, ctx->specific, VSB_MAGIC);

	if (blob == NULL || blob->len == 0)
		return;
	AN(blob->priv);
	if (VSB_bcat(vsb, blob->priv, blob->len))
		VRT_fail(ctx, "blobsynth.synthetic(): %s",
		strerror(VSB_error(vsb)));
}
